/******************************************************************************

    Program:        pdf_func.i
    
    Written By:     Gordon Campbell - PRO-SYS Consultants Ltd.
    Written On:     January 8, 2004
    
    Description:    Contains function declaration.  Copied from pdf_inc.i
                    on January 8, 2004.
                    
                    This was done so that pdftool.p could also declare the
                    functions without having to use pdf_inc.i.
                    
    Arguments:      {1} - handle to the pdf_inc.p procedure

    History:        
    
    01/08/04  G Campbell    Added Function pdf_get_tool_parameter
                    
    01/21/04  G Campbell    Added function pdf_GetNumFittingChars
                            Added function pdf_text_widthdec

******************************************************************************/

FUNCTION pdf_Font RETURN CHARACTER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_FontType RETURN CHARACTER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_ImageDim RETURN INTEGER ( INPUT pdfStream AS CHARACTER,
                                       INPUT pdfImage  AS CHARACTER,
                                       INPUT pdfDim    AS CHARACTER) IN {1}.
FUNCTION pdf_TextX RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_TextY RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_VerticalSpace RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_PointSize RETURN DECIMAL ( INPUT pdfStream AS CHARACTER ) IN {1}.
FUNCTION pdf_text_width RETURNS INTEGER ( INPUT pdfStream   AS CHARACTER,
                                          INPUT pdfText     AS CHARACTER) IN {1}.
FUNCTION pdf_text_widthdec RETURNS DECIMAL ( INPUT pdfStream   AS CHARACTER,
                                             INPUT pdfText     AS CHARACTER) IN {1}.
FUNCTION pdf_TextRed RETURN DECIMAL ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_TextGreen RETURN DECIMAL ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_TextBlue RETURN DECIMAL ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_FillRed RETURN DECIMAL ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_FillGreen RETURN DECIMAL ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_FillBlue RETURN DECIMAL ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_Page RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_PageWidth RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_Pageheight RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_PageRotate RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_Angle RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_TopMargin RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_BottomMargin RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_GraphicX RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_GraphicY RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_get_info RETURNS CHARACTER ( INPUT pdfStream    AS CHARACTER,
                                          INPUT pdfAttribute AS CHARACTER) IN {1}.
FUNCTION pdf_LeftMargin RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_GetNumFittingChars RETURNS INTEGER 
                                ( INPUT pdfStream   AS CHARACTER,
                                  INPUT pdfText     AS CHARACTER,
                                  INPUT pdfFromX    AS INTEGER,
                                  INPUT pdfToX      AS INTEGER ) IN {1}.
FUNCTION pdf_Orientation RETURN CHARACTER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_PaperType RETURN CHARACTER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_Render RETURN INTEGER ( INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_get_wrap_length RETURNS INTEGER ( INPUT pdfStream   AS CHARACTER,
                                               INPUT pdfText AS CHARACTER,
                                               INPUT pdfWidth AS INTEGER ) IN {1}.
FUNCTION pdf_TotalPages RETURN CHARACTER (INPUT pdfStream AS CHARACTER) IN {1}.
FUNCTION pdf_PageFooter RETURN LOGICAL (INPUT pdfStream     AS CHARACTER,
                                        INPUT pdfProcHandle AS HANDLE,
                                        INPUT pdfFooterProc AS CHARACTER) IN {1}.
FUNCTION pdf_PageHeader RETURN LOGICAL (INPUT pdfStream     AS CHARACTER,
                                        INPUT pdfProcHandle AS HANDLE,
                                        INPUT pdfHeaderProc AS CHARACTER) IN {1}.
FUNCTION pdf_LastProcedure RETURN LOGICAL (INPUT pdfStream     AS CHARACTER,
                                           INPUT pdfProcHandle AS HANDLE,
                                           INPUT pdfHeaderProc AS CHARACTER) IN {1}.
FUNCTION pdf_get_tool_parameter RETURNS CHARACTER
        (INPUT  pdfStream      AS CHARACTER,
         INPUT  pdfToolName    AS CHARACTER,
         INPUT  pdfToolParam   AS CHARACTER,
         INPUT  pdfToolCol     AS INTEGER) IN {1}.
